﻿@publishTestResults @bypass-integration
Feature: Publish Python Behave Json Test Results

Scenario: Publish a Python Behave Json Scenario test result
	Given there is a remote server project prepared for publishing test results
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
			Then there should be something
		"""
	And there is a Python Behave JSON test result file as
		"""
		[
		{
		  "elements": [
			{
			  "keyword": "Scenario",
			  "location": "features/SampleFeature.feature:4",
			  "name": "Sample scenario",
			  "status": "passed",
			  "steps": [
				{
				  "keyword": "When",
				  "location": "features/SampleFeature.feature:5",
				  "match": {
					"arguments": [],
					"location": "features/steps/steps.py:5"
				  },
				  "name": "I do something",
				  "result": {
					"duration": 0.0,
					"status": "passed"
				  },
				  "step_type": "when"
				},
				{
				  "keyword": "Then",
				  "location": "features/SampleFeature.feature:6",
				  "match": {
					"arguments": [],
					"location": "features/steps/sample_steps.py:3"
				  },
				  "name": "there should be something",
				  "result": {
					"duration": 0.0,
					"status": "passed"
				  },
				  "step_type": "then"
				}
			  ],
			  "tags": [
				"tc:1043950"
			  ],
			  "type": "scenario"
			}
		  ],
		  "keyword": "Feature",
		  "location": "features/SampleFeature.feature:1",
		  "name": "Sample feature",
		  "status": "passed",
		  "tags": []
		}
		]
		"""
	When the test result is published to Test Configuration "Windows 8"
	Then the command should not fail
	And the there should be a Test Run registered with test results
		| test case ID      | outcome | step outcomes |
		| [id-of-test-case] | Passed  | Passed,Passed |

Scenario: Publish a Python Behave Json Scenario Outline test result
	Given there is a remote server project prepared for publishing test results
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario Outline: Sample scenario outline
			Given there is something
			When I do <what>
			Then there should be something
		Examples:
			| what            |
			| something       |
			| something wrong |
		"""
	And there is a Python Behave JSON test result file as
		"""
        [
        {
          "elements": [
            {
              "keyword": "Scenario Outline",
              "location": "features/SampleFeature.feature:10",
              "name": "Sample scenario outline -- @1.1 ",
              "status": "passed",
              "steps": [
                {
                  "keyword": "Given",
                  "location": "features/SampleFeature.feature:5",
                  "match": {
                    "arguments": [],
                    "location": "features/steps/sample_steps.py:7"
                  },
                  "name": "there is something",
                  "result": {
                    "duration": 0.0,
                    "status": "passed"
                  },
                  "step_type": "given"
                },
                {
                  "keyword": "When",
                  "location": "features/SampleFeature.feature:6",
                  "match": {
                    "arguments": [],
                    "location": "features/steps/steps.py:5"
                  },
                  "name": "I do something",
                  "result": {
                    "duration": 0.0,
                    "status": "passed"
                  },
                  "step_type": "when"
                },
                {
                  "keyword": "Then",
                  "location": "features/SampleFeature.feature:7",
                  "match": {
                    "arguments": [],
                    "location": "features/steps/sample_steps.py:3"
                  },
                  "name": "there should be something",
                  "result": {
                    "duration": 0.0,
                    "status": "passed"
                  },
                  "step_type": "then"
                }
              ],
              "tags": [
                "tc:1043951"
              ],
              "type": "scenario"
            },
            {
              "keyword": "Scenario Outline",
              "location": "features/SampleFeature.feature:11",
              "name": "Sample scenario outline -- @1.2 ",
              "status": "failed",
              "steps": [
                {
                  "keyword": "Given",
                  "location": "features/SampleFeature.feature:5",
                  "match": {
                    "arguments": [],
                    "location": "features/steps/sample_steps.py:7"
                  },
                  "name": "there is something",
                  "result": {
                    "duration": 0.0,
                    "status": "passed"
                  },
                  "step_type": "given"
                },
                {
                  "keyword": "When",
                  "location": "features/SampleFeature.feature:6",
                  "match": {
                    "arguments": [],
                    "location": "features/steps/sample_steps.py:11"
                  },
                  "name": "I do something wrong",
                  "result": {
                    "duration": 0.0,
                    "error_message": "Assertion Failed: simulated error",
                    "status": "failed"
                  },
                  "step_type": "when"
                },
                {
                  "keyword": "Then",
                  "location": "features/SampleFeature.feature:7",
                  "name": "there should be something",
                  "step_type": "then"
                }
              ],
              "tags": [
                "tc:1043951"
              ],
              "type": "scenario"
            }
          ],
          "keyword": "Feature",
          "location": "features/SampleFeature.feature:1",
          "name": "Sample feature",
          "status": "failed",
          "tags": []
        }
        ]
		"""
	When the test result is published successfully
	Then the there should be a Test Run registered with test results
		| test case ID      | outcome | iteration outcomes | iteration step outcomes                            |
		| [id-of-test-case] | Failed  | (Passed),(Failed)  | (Passed,Passed,Passed),(Passed,Failed,NotExecuted) |
